diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index c8e6c6a0f..368e5aa3d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -23,18 +23,18 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
     }
     @Override
     public boolean render(Tessellator t, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
-        float brightness = getBlockBrightness(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
 
         float cBottom = 0.5F;
         float cTop = 1.0F;
         float cNorthSouth = 0.8F;
         float cEastWest = 0.6F;
 
-        boolean connectNorth = block.canConnectTo(renderBlocks.world, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY(), z + Direction.NORTH.getOffsetZ());
-        boolean connectSouth = block.canConnectTo(renderBlocks.world, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY(), z + Direction.SOUTH.getOffsetZ());
-        boolean connectEast = block.canConnectTo(renderBlocks.world, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY(), z + Direction.EAST.getOffsetZ());
-        boolean connectWest = block.canConnectTo(renderBlocks.world, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY(), z + Direction.WEST.getOffsetZ());
+        boolean connectNorth = block.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY(), z + Direction.NORTH.getOffsetZ());
+        boolean connectSouth = block.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY(), z + Direction.SOUTH.getOffsetZ());
+        boolean connectEast = block.canConnectTo(renderBlocks.blockAccess, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY(), z + Direction.EAST.getOffsetZ());
+        boolean connectWest = block.canConnectTo(renderBlocks.blockAccess, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY(), z + Direction.WEST.getOffsetZ());
 
         boolean lineNorthSouth = connectNorth && connectSouth;
         boolean lineEastWest = connectEast && connectWest;
@@ -70,19 +70,19 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
         double fenceBottommostMaxU = fenceBottommostTex.getSubIconU(onePix * 16);
         double fenceBottommostMaxV = fenceBottommostTex.getSubIconV(onePix * 16);
 
-        Block blockAbove = renderBlocks.world.getBlock(x, y + 1, z);
-        boolean connectUpNorth = blockAbove == block && block.canConnectTo(renderBlocks.world, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() + 1, z + Direction.NORTH.getOffsetZ());
-        boolean connectUpSouth = blockAbove == block && block.canConnectTo(renderBlocks.world, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() + 1, z + Direction.SOUTH.getOffsetZ());
-        boolean connectUpEast = blockAbove == block && block.canConnectTo(renderBlocks.world, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() + 1, z + Direction.EAST.getOffsetZ());
-        boolean connectUpWest = blockAbove == block && block.canConnectTo(renderBlocks.world, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() + 1, z + Direction.WEST.getOffsetZ());
+        Block blockAbove = renderBlocks.blockAccess.getBlock(x, y + 1, z);
+        boolean connectUpNorth = blockAbove == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() + 1, z + Direction.NORTH.getOffsetZ());
+        boolean connectUpSouth = blockAbove == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() + 1, z + Direction.SOUTH.getOffsetZ());
+        boolean connectUpEast = blockAbove == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() + 1, z + Direction.EAST.getOffsetZ());
+        boolean connectUpWest = blockAbove == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() + 1, z + Direction.WEST.getOffsetZ());
 
-        Block blockBelow = renderBlocks.world.getBlock(x, y - 1, z);
-        boolean connectDownNorth = blockBelow == block && block.canConnectTo(renderBlocks.world, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() - 1, z + Direction.NORTH.getOffsetZ());
-        boolean connectDownSouth = blockBelow == block && block.canConnectTo(renderBlocks.world, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() - 1, z + Direction.SOUTH.getOffsetZ());
-        boolean connectDownEast = blockBelow == block && block.canConnectTo(renderBlocks.world, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() - 1, z + Direction.EAST.getOffsetZ());
-        boolean connectDownWest = blockBelow == block && block.canConnectTo(renderBlocks.world, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() - 1, z + Direction.WEST.getOffsetZ());
+        Block blockBelow = renderBlocks.blockAccess.getBlock(x, y - 1, z);
+        boolean connectDownNorth = blockBelow == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() - 1, z + Direction.NORTH.getOffsetZ());
+        boolean connectDownSouth = blockBelow == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() - 1, z + Direction.SOUTH.getOffsetZ());
+        boolean connectDownEast = blockBelow == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() - 1, z + Direction.EAST.getOffsetZ());
+        boolean connectDownWest = blockBelow == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() - 1, z + Direction.WEST.getOffsetZ());
 
-        if (block.shouldDrawColumn(renderBlocks.world, x, y, z))
+        if (block.shouldDrawColumn(renderBlocks.blockAccess, x, y, z))
         {
             double sidesMinU = columnTexIndex.getIconUMin();
             double sidesMinV = columnTexIndex.getIconVMin();
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index 4c2a7e16d..a493c0a0b 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -19,7 +19,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
         if(renderBlocks.overrideBlockTexture != null)
         {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 2656b26b8..1130c10e5 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -17,8 +17,8 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.blockAccess, x, y, z);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
index 974410591..7a7c99e72 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
@@ -15,11 +15,11 @@ public class BlockModelJar<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         // todo: yes, i know this is horrible.
-        float brightness = getBlockBrightness(renderBlocks.world, x, y, z);
+        float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
         float yOffset = 0f;
-        int meta = renderBlocks.world.getBlockMetadata(x, y, z);
+        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
 
         float extMinX = x + 0.5f - (3f / 16f);
         float extMinY = y + yOffset;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
index 19333b238..db427f2a5 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
@@ -12,7 +12,7 @@ public class BlockModelLadder<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int k1 = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         IconCoordinate l = getBlockTextureFromSideAndMetadata(Side.BOTTOM, k1);
         if(renderBlocks.overrideBlockTexture != null)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
index d220fd7ed..12909291f 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
@@ -12,12 +12,12 @@ public class BlockModelLantern<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
-        int meta = renderBlocks.world.getBlockMetadata(x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         boolean isHanging = (meta & 0b00000001) == 0;
         boolean isAngled = (meta & 0b00000010) != 0;
 
-        float brightness = getBlockBrightness(renderBlocks.world, x, y, z);
+        float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
 
         float yOffset = isHanging ? 0f : 0.375f;
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
index 6ff39c372..e7955c3ee 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
@@ -13,7 +13,7 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T>{
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         int i1 = l & 7;
         boolean flag = (l & 8) > 0;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java
index 3bd84387d..9ec74f661 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java
@@ -16,7 +16,7 @@ public class BlockModelMossyStone<T extends Block> extends BlockModelStandard<T>
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         renderStandardBlock(tessellator, block, x, y, z, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = mossOverlay;
         renderStandardBlock(tessellator, block, x, y, z);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
index fee474548..3a237f44b 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
@@ -19,17 +19,17 @@ public class BlockModelPebbles<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         float f1 = 1.0F;
 
-        float f4 = getBlockBrightness(renderBlocks.world, x, y, z);
-        float f5 = getBlockBrightness(renderBlocks.world, x, y - 1, z);
+        float f4 = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        float f5 = getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z);
         if(f5 < f4)
         {
             f5 = f4;
         }
         tessellator.setColorOpaque_F(f1 * f5, f1 * f5, f1 * f5);
-        IconCoordinate j = getBlockTextureFromSideAndMetadata(Side.TOP, renderBlocks.world.getBlockMetadata(x, y, z));
+        IconCoordinate j = getBlockTextureFromSideAndMetadata(Side.TOP, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
         renderTopFace(tessellator, block, x, y, z, j);
 
         return true;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
index 5e2fad6e1..484b0421f 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
@@ -19,7 +19,7 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
     }
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z){
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         return renderPistonBase(tessellator, x, y, z, false);
     }
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
index 30911462f..01b4e26fb 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
@@ -18,7 +18,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         return renderPistonHead(tessellator, block, x, y, z, true);
     }
     public void renderPistonHeadNoCulling(Tessellator tessellator, BlockPistonHead block, int x, int y, int z, boolean flag) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index 2b676c8c0..7145f807d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -20,7 +20,7 @@ public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         IconCoordinate i1 = getBlockTextureFromSideAndMetadata(Side.BOTTOM, l);
         if(renderBlocks.overrideBlockTexture != null)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java
index 3f65d860f..93be5df8f 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java
@@ -13,11 +13,12 @@ public class BlockModelRedstoneWire<T extends Block> extends BlockModelStandard<
     protected IconCoordinate wireCross = TextureRegistry.getTexture("minecraft:block/wire_redstone_cross");
     public BlockModelRedstoneWire(Block block) {
         super(block);
+        withTextures("minecraft:block/wire_redstone_cross");
     }
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         if(renderBlocks.overrideBlockTexture != null)
         {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
index 0c046b458..76e0c5be0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
@@ -16,7 +16,7 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRedstoneRepeater
     }
 
     public boolean render(Tessellator tessellator, int x, int y, int z){
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         int i1 = l & 3;
         int j1 = (l & 0xc) >> 2;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
index a7d363cd2..fe78ba935 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -1,11 +1,9 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockRope;
-import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public class BlockModelRope<T extends BlockRope>
 extends BlockModelStandard<T> {
@@ -15,54 +13,66 @@ extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        World world = renderBlocks.world;
+        WorldSource world = renderBlocks.blockAccess;
+        boolean hasFloor = world.isBlockOpaqueCube(x, y - 1, z);
         boolean hasBlockNegX = world.getBlockId(x - 1, y, z) == block.id;
         boolean hasBlockPosX = world.getBlockId(x + 1, y, z) == block.id;
-        boolean hasBlockNegY = world.getBlockId(x, y - 1, z) == block.id;
+        boolean hasBlockNegY = world.getBlockId(x, y - 1, z) == block.id || hasFloor;
         boolean hasBlockPosY = world.getBlockId(x, y + 1, z) == block.id || world.isBlockOpaqueCube(x, y + 1, z);
         boolean hasBlockNegZ = world.getBlockId(x, y, z - 1) == block.id;
         boolean hasBlockPosZ = world.getBlockId(x, y, z + 1) == block.id;
 
+
         boolean drawKnot =  !(hasBlockNegX && hasBlockPosX && !hasBlockNegY && !hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
             !(!hasBlockNegX && !hasBlockPosX && hasBlockNegY && hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
             !(!hasBlockNegX && !hasBlockPosX && !hasBlockNegY && !hasBlockPosY && hasBlockNegZ && hasBlockPosZ);
 
         block.setBlockBounds(0, 0, 0, 1, 1, 1);
 
+        final float ropeThickness = (1 / 16f);
+        final float knotThickness = (2 / 16f);
+        final float pileWidth = (3 / 16f);
+
         if (drawKnot)
         {
-            block.setBlockBounds(0.5f - (2 / 16f), 0.5f - (2 / 16f), 0.5f - (2 / 16f), 0.5f + (2 / 16f), 0.5f + (2 / 16f), 0.5f + (2 / 16f));
+            block.setBlockBounds(0.5f - knotThickness, 0.5f - knotThickness, 0.5f - knotThickness, 0.5f + knotThickness, 0.5f + knotThickness, 0.5f + knotThickness);
             renderStandardBlock(tessellator, block, x, y, z);
         }
 
         if (hasBlockPosY)
         {
-            block.setBlockBounds(0.5f - (1 / 16f), 0.5f, 0.5f - (1 / 16f), 0.5f + (1 / 16f), 1, 0.5f + (1 / 16f));
+            block.setBlockBounds(0.5f - ropeThickness, 0.5f, 0.5f - ropeThickness, 0.5f + ropeThickness, 1, 0.5f + ropeThickness);
             renderStandardBlock(tessellator, block, x, y, z);
         }
         if (hasBlockNegY)
         {
-            block.setBlockBounds(0.5f - (1 / 16f), 0, 0.5f - (1 / 16f), 0.5f + (1 / 16f), 0.5f, 0.5f + (1 / 16f));
+            block.setBlockBounds(0.5f - ropeThickness, 0, 0.5f - ropeThickness, 0.5f + ropeThickness, 0.5f, 0.5f + ropeThickness);
             renderStandardBlock(tessellator, block, x, y, z);
         }
         if (hasBlockPosX)
         {
-            block.setBlockBounds(0.5f, 0.5f - (1 / 16f), 0.5f - (1 / 16f), 1, 0.5f + (1 / 16f), 0.5f + (1 / 16f));
+            block.setBlockBounds(0.5f, 0.5f - ropeThickness, 0.5f - ropeThickness, 1, 0.5f + ropeThickness, 0.5f + ropeThickness);
             renderStandardBlock(tessellator, block, x, y, z);
         }
         if (hasBlockNegX)
         {
-            block.setBlockBounds(0, 0.5f - (1 / 16f), 0.5f - (1 / 16f), 0.5f, 0.5f + (1 / 16f), 0.5f + (1 / 16f));
+            block.setBlockBounds(0, 0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness);
             renderStandardBlock(tessellator, block, x, y, z);
         }
         if (hasBlockPosZ)
         {
-            block.setBlockBounds(0.5f - (1 / 16f), 0.5f - (1 / 16f), 0.5f, 0.5f + (1 / 16f), 0.5f + (1 / 16f), 1);
+            block.setBlockBounds(0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness, 1);
             renderStandardBlock(tessellator, block, x, y, z);
         }
         if (hasBlockNegZ)
         {
-            block.setBlockBounds(0.5f - (1 / 16f), 0.5f - (1 / 16f), 0f, 0.5f + (1 / 16f), 0.5f + (1 / 16f), 0.5f);
+            block.setBlockBounds(0.5f - ropeThickness, 0.5f - ropeThickness, 0f, 0.5f + ropeThickness, 0.5f + ropeThickness, 0.5f);
+            renderStandardBlock(tessellator, block, x, y, z);
+        }
+        if (hasFloor){
+            block.setBlockBounds(0.5f - pileWidth, 0,0.5f - pileWidth, 0.5f + pileWidth, knotThickness, 0.5f + pileWidth);
+            renderStandardBlock(tessellator, block, x, y, z);
+            block.setBlockBounds(0.5f - knotThickness, 0,0.5f - knotThickness, 0.5f + knotThickness, ropeThickness * 3, 0.5f + knotThickness);
             renderStandardBlock(tessellator, block, x, y, z);
         }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
index c02c812f3..bf01b719c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
@@ -11,7 +11,7 @@ public class BlockModelSeat<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
 
         setRenderSide(Side.BOTTOM, false); // Set bottom face to not render
         renderStandardBlock(tessellator, block, x, y, z); // Render seat
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
index 308854ff4..3d2ae764f 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
@@ -13,7 +13,7 @@ public class BlockModelSpikes<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int metaData = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.EAST, metaData);
         if(renderBlocks.overrideBlockTexture != null)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index 484b2c605..997b2ee50 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -17,7 +17,7 @@ public class BlockModelStairs<T extends BlockStairs> extends BlockModelStandard<
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         int hRotation = meta & 0b0011;
         int vRotation = meta & 0b1000;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index 9a80df6e4..1d75ba6ac 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -10,7 +10,9 @@ import net.minecraft.core.world.WorldSource;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelStandard<T extends Block> extends BlockModel<T>{
-    public IconCoordinate[] atlasIndices = new IconCoordinate[6];
+    public static final IconCoordinate BLOCK_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:block/texture_missing");
+    public static final IconCoordinate BLOCK_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:block/texture_unassigned");
+    public IconCoordinate[] atlasIndices = new IconCoordinate[]{BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED};
     public double[] itemRenderBounds = null;
     public IconCoordinate overbrightTexture = null;
 
@@ -20,7 +22,7 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         return renderStandardBlock(tessellator, block, x, y, z);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
index fdd82f758..de235fe84 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
@@ -12,7 +12,7 @@ public class BlockModelTorch<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         float f = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
         if(Block.lightEmission[block.id] > 0)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index 5be959d5f..b484f9e34 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -18,7 +18,7 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.world, x, y, z);
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         boolean isUp = BlockTrapDoor.isTrapdoorOpen(metadata);
 
